import cherrypy
import os
from pathlib import Path
 
 
class WebServer:
    
    def __init__(self):
        soubory = Path('public')
        if not soubory.exists():
            soubory.mkdir()
    
    @cherrypy.expose
    def index(self):
        return f"""
            Zdraví Vás Váš osobní webový server!
            <br>
            <form method="post" action="upload" enctype="multipart/form-data">
                <input type="file" name="soubor">
                <input type="submit">
            </form>
        """
    
    @cherrypy.expose
    def upload(self, soubor):
        # načtení a uložení dat nahraného obrázku
        data = soubor.file.read()
        with open(f'public/{soubor.filename}', 'bw') as f:
            f.write(data)
        # výpočet a uložení negativu
        ...
        # zobrazení výsledné HTML-stránky
        return f"""
            binární data o délce {len(data)} bajtů
            <br>
            <img src="soubory/{soubor.filename}">
            <br>
            <img src="soubory/{soubor.filename}">
        """


if __name__ == '__main__':
    config = {
        '/soubory': {
            'tools.staticdir.on': True,
            'tools.staticdir.root': os.path.abspath(os.getcwd()),
            'tools.staticdir.dir': './public',
        },
    }
    cherrypy.quickstart(WebServer(), '/', config)
