import cherrypy
from pathlib import Path
from PIL import Image
 
 
class WebServer:
    
    def __init__(self):
        soubory = Path('public')
        if not soubory.exists():
            soubory.mkdir()
    
    @cherrypy.expose
    def index(self):
        return f"""
            Zdraví Vás Váš osobní webový server!
            <br>
            <form method="post" action="upload" enctype="multipart/form-data">
                <input type="file" name="soubor">
                <input type="submit">
            </form>
        """
    
    @cherrypy.expose
    def upload(self, soubor):
        # načtení a uložení dat nahraného obrázku
        data = soubor.file.read()
        with open(f'public/{soubor.filename}', 'bw') as f:
            f.write(data)
        # výpočet a uložení negativu
        obrázek = Image.open(f'public/{soubor.filename}')
        ...
        # zobrazení výsledné HTML-stránky
        return f"""
            binární data o délce {len(data)} bajtů
            <br>
            <img src="soubory/{soubor.filename}">
            <br>
            {dir(obrázek)}
        """


if __name__ == '__main__':
    config = {
        '/soubory': {   # název adresáře 'public' pro použití uvnitř vraceného HTML-textu
            'tools.staticdir.on': True,
            'tools.staticdir.root': Path().cwd().resolve(), # absolutní cesta k místu spuštění serveru
            'tools.staticdir.dir': './public',  # skutečné jméno adresáře pro ukládání souborů relativně k místu spuštění serveru
        },
    }
    cherrypy.quickstart(WebServer(), '/', config)
